
% Lectura del fichero SOLUCIONES generado previamente.
% masa, zona de alerta, zona de intervencin, zona efecto domin.

fID = fopen('solucionesTrain.txt');             % Apertura del fichero.
i=0;
while ~feof(fID)                                % Test 'Lnea Final'.
    i=i+1;                                      % Incrementa contador
    lin=fgetl(fID);                             % Devuelve la siguiente lnea. 
    posB=find(lin==',');                        % Localiza la primera coma.
    masaTrain(i)=str2double(lin(1:posB(1)-1));       % Extrae la masa (termina en coma -1).
    zaTrain(i)=str2double(lin(posB(1)+1:posB(2)-1)); % Extrae Zona de Alerta.
    ziTrain(i)=str2double(lin(posB(2)+1:posB(3)-1)); % Extrae Zona de Intervencin.
    zdTrain(i)=str2double(lin(posB(3)+1:end));       % Extrae Zona Efecto Domin.
end

fID = fopen('solucionesTest.txt');              % Apertura del fichero.
i=0;
while ~feof(fID)                                % Test 'Lnea Final'.
    i=i+1;                                      % Incrementa contador
    lin=fgetl(fID);                             % Devuelve la siguiente lnea. 
    posB=find(lin==',');                        % Localiza la primera coma.
    masaTest(i)=str2double(lin(1:posB(1)-1));       % Extrae la masa (termina en coma -1).
    zaTest(i)=str2double(lin(posB(1)+1:posB(2)-1)); % Extrae Zona de Alerta.
    ziTest(i)=str2double(lin(posB(2)+1:posB(3)-1)); % Extrae Zona de Intervencin.
    zdTest(i)=str2double(lin(posB(3)+1:end));       % Extrae Zona Efecto Domin.
end

% Normalizacin entre 0.1 y 0.9 (aproximadamente).

masa_minima=min(min(masaTrain),min(masaTest));  % Busca el mnimo y mximo de cada variable.
masa_maxima=max(max(masaTrain),max(masaTest));
za_minima=min(min(zaTrain),min(zaTest));
za_maxima=max(max(zaTrain),max(zaTest));
zi_minima=min(min(ziTrain),min(ziTest));
zi_maxima=max(max(ziTrain),max(ziTest));
zd_minima=min(min(zdTrain),min(zdTest));
zd_maxima=max(max(zdTrain),max(zdTest));

nuevoIntervalo=0.8;                             % 0.9 - 0.1

%Normaliza en conjunto de entrenamiento.
masaEscaladaTrain=0.1+(masaTrain-masa_minima)*nuevoIntervalo/(masa_maxima-masa_minima);
zaEscaladaTrain=0.1+(zaTrain-za_minima)*nuevoIntervalo/(za_maxima-za_minima);
ziEscaladaTrain=0.1+(ziTrain-zi_minima)*nuevoIntervalo/(zi_maxima-zi_minima);
zdEscaladaTrain=0.1+(zdTrain-zd_minima)*nuevoIntervalo/(zd_maxima-zd_minima);

%Normaliza el conjunto de test.
masaEscaladaTest=0.1+(masaTest-masa_minima)*nuevoIntervalo/(masa_maxima-masa_minima);
zaEscaladaTest=0.1+(zaTest-za_minima)*nuevoIntervalo/(za_maxima-za_minima);
ziEscaladaTest=0.1+(ziTest-zi_minima)*nuevoIntervalo/(zi_maxima-zi_minima);
zdEscaladaTest=0.1+(zdTest-zd_minima)*nuevoIntervalo/(zd_maxima-zd_minima);

% Escritura del fichero con los resultados.

fID=fopen('solucionesNormalTrain.txt','wt');            % Crea fichero de salida
formato='%5.5f %5.5f %5.5f %5.5f\n';                    % Define formato.
for i=1:length(masaTrain)                               % Para cada masa inserta...
    fprintf(fID,'%5.5f, ',masaEscaladaTrain(i));        % ... masa, ...
    fprintf(fID,'%5.5f, ',zaEscaladaTrain(i));          % ... Zona de Alerta, ...
    fprintf(fID,'%5.5f, ',ziEscaladaTrain(i));          % ... Zona de Intervencin, ...
    fprintf(fID,'%5.5f \n',zdEscaladaTrain(i));         % ... Zona de Efecto Domin.
end
fclose(fID);

fID=fopen('solucionesNormalTest.txt','wt');            % Crea fichero de salida
formato='%5.5f %5.5f %5.5f %5.5f\n';                   % Define formato.
for i=1:length(masaTest)                               % Para cada masa inserta...
    fprintf(fID,'%5.5f, ',masaEscaladaTest(i));        % ... masa, ...
    fprintf(fID,'%5.5f, ',zaEscaladaTest(i));          % ... Zona de Alerta, ...
    fprintf(fID,'%5.5f, ',ziEscaladaTest(i));          % ... Zona de Intervencin, ...
    fprintf(fID,'%5.5f \n',zdEscaladaTest(i));         % ... Zona de Efecto Domin.
end
fclose(fID);
