
clear all

% Lectura del fichero SOLUCIONES de Test generado previamente.
% masa, zona de alerta, zona de intervencin, zona efecto domin.

fID = fopen('solucionesTrain.txt');             % Apertura del fichero.
i=0;
while ~feof(fID)                                % Test 'Lnea Final'.
    i=i+1;                                      % Incrementa contador
    lin=fgetl(fID);                             % Devuelve la siguiente lnea. 
    posB=find(lin==',');                        % Localiza la primera coma.
    masaTrain(i)=str2double(lin(1:posB(1)-1));       % Extrae la masa (termina en coma -1).
    zaTrain(i)=str2double(lin(posB(1)+1:posB(2)-1)); % Extrae Zona de Alerta.
    ziTrain(i)=str2double(lin(posB(2)+1:posB(3)-1)); % Extrae Zona de Intervencin.
    zdTrain(i)=str2double(lin(posB(3)+1:end));       % Extrae Zona Efecto Domin.
end

fID = fopen('solucionesTest.txt');              % Apertura del fichero.
i=0;
while ~feof(fID)                                % Test 'Lnea Final'.
    i=i+1;                                      % Incrementa contador
    lin=fgetl(fID);                             % Devuelve la siguiente lnea. 
    posB=find(lin==',');                        % Localiza la primera coma.
    masaTest(i)=str2double(lin(1:posB(1)-1));       % Extrae la masa (termina en coma -1).
    zaTest(i)=str2double(lin(posB(1)+1:posB(2)-1)); % Extrae Zona de Alerta.
    ziTest(i)=str2double(lin(posB(2)+1:posB(3)-1)); % Extrae Zona de Intervencin.
    zdTest(i)=str2double(lin(posB(3)+1:end));       % Extrae Zona Efecto Domin.
end

% Desnormalizacin.

masa_minima=min(min(masaTrain),min(masaTest));  % Busca el mnimo y mximo de cada variable.
masa_maxima=max(max(masaTrain),max(masaTest));
za_minima=min(min(zaTrain),min(zaTest));
za_maxima=max(max(zaTrain),max(zaTest));
zi_minima=min(min(ziTrain),min(ziTest));
zi_maxima=max(max(ziTrain),max(ziTest));
zd_minima=min(min(zdTrain),min(zdTest));
zd_maxima=max(max(zdTrain),max(zdTest));

Intervalo=0.8;                                  % 0.9 - 0.1

% Lectura del fichero de soluciones aportado por la red.

fID = fopen('salidaPrediccionesID24_200000.csv');              % Apertura del fichero.
i=0;
while ~feof(fID)                                    % Test 'Lnea Final'.
    i=i+1;                                          % Incrementa contador
    lin=fgetl(fID);                                 % Devuelve la siguiente lnea.
    prediccion(i)=str2double(lin);                  % Extrae las predicciones de la red.
end

% Desnormaliza el conjunto de test.
prediccionZa=(((prediccion-0.1)*(za_maxima-za_minima))+(za_minima*(Intervalo)))/(Intervalo);
prediccionZi=(((prediccion-0.1)*(zi_maxima-zi_minima))+(zi_minima*(Intervalo)))/(Intervalo);
prediccionZd=(((prediccion-0.1)*(zd_maxima-zd_minima))+(zd_minima*(Intervalo)))/(Intervalo);

% Ordeno de menor a mayor para quedarme con los 50 casos ms pequeos.

masaTest=sort(masaTest);
masaTest=masaTest(1:100);
zaTest=sort(zaTest);
zaTest=zaTest(1:100);
ziTest=sort(ziTest);
ziTest=ziTest(1:100);
zdTest=sort(zdTest);
zdTest=zdTest(1:100);
prediccionZa=sort(prediccionZa);
prediccionZa=prediccionZa(1:100);
prediccionZi=sort(prediccionZi);
prediccionZi=prediccionZi(1:100);
prediccionZd=sort(prediccionZd);
prediccionZd=prediccionZd(1:100);

% Grafica los resultados.

figure()
plot (masaTest,zaTest,'x');
hold on
plot (masaTest,prediccionZa,'or');
title 'Zona de Alerta';
xlabel 'Masa [kg]';
ylabel 'Distancia [m]';
grid on;

% figure()
% plot (masaTest,ziTest,'x');
% hold on
% plot (masaTest,prediccionZi,'or');
% title 'Zona de Intervencion';
% xlabel 'Masa [kg]';
% ylabel 'Distancia [m]';
% grid on;
% 
% figure()
% plot (masaTest,zdTest,'x');
% hold on
% plot (masaTest,prediccionZd,'or');
% title 'Zona de Efecto Domino';
% xlabel 'Masa [kg]';
% ylabel 'Distancia [m]';
% grid on;

% Test de Student.

[hZa,pZa]=TTEST2(zaTest,prediccionZa,0.05);
[hZi,pZi]=TTEST2(ziTest,prediccionZi,0.05);
[hZd,pZd]=TTEST2(zdTest,prediccionZd,0.05);

InvPZa=1-pZa;
InvPZi=1-pZi;
InvPZd=1-pZd;


