
clear;

% Lectura de ficheros generados previamente.
% Nos quedamos con las masas en un nico vector.

fID = fopen('solucionesTrain.txt');             % Apertura del fichero.
i=0;
while ~feof(fID)                                % Test 'Lnea Final'.
    i=i+1;                                      % Incrementa contador
    lin=fgetl(fID);                             % Devuelve la siguiente lnea. 
    posB=find(lin==',');                        % Localiza la primera coma.
    masaTrain(i)=str2double(lin(1:posB(1)-1));  % Extrae la masa (termina en coma -1).
    zaTrain(i)=str2double(lin(posB(1)+1:posB(2)-1)); % Extrae Zona de Alerta.
    ziTrain(i)=str2double(lin(posB(2)+1:posB(3)-1)); % Extrae Zona de Intervencin.
    zdTrain(i)=str2double(lin(posB(3)+1:end));       % Extrae Zona Efecto Domin.
end

fID = fopen('solucionesTest.txt');              % Apertura del fichero.
i=0;
while ~feof(fID)                                % Test 'Lnea Final'.
    i=i+1;                                      % Incrementa contador
    lin=fgetl(fID);                             % Devuelve la siguiente lnea. 
    posB=find(lin==',');                        % Localiza la primera coma.
    masaTest(i)=str2double(lin(1:posB(1)-1));   % Extrae la masa (termina en coma -1).
    zaTest(i)=str2double(lin(posB(1)+1:posB(2)-1)); % Extrae Zona de Alerta.
    ziTest(i)=str2double(lin(posB(2)+1:posB(3)-1)); % Extrae Zona de Intervencin.
    zdTest(i)=str2double(lin(posB(3)+1:end));       % Extrae Zona Efecto Domin.
end

masa=[masaTrain masaTest];

% Extrae la masa mxima.

fID = fopen('Informacion.txt');                 % Apertura del fichero.
lin=fgetl(fID);                                 % Devuelve la siguiente lnea. 
posB=find(lin==',');                            % Localiza la primera coma.
sustancia=lin(1:posB(1)-1);                     % Extrae el Nombre (termina en coma -1).
equi_TNT=str2double(lin(posB(1)+1:posB(2)-1));  % Extrae Masa equivalente.
masa_min=str2double(lin(posB(2)+1:posB(3)-1));  % Extrae Masa mnima.
masa_max=str2double(lin(posB(3)+1:posB(4)-1));  % Extrae Masa mxima.
genera_set=str2double(lin(posB(4)+1:end));      % Nmero de simulacones para el set.

% El vector masa debe tener todos aquellos nmeros no usados previamente.

% indice=0;
% for i=1:masa_max
%     valor=find(masa==i);
%     if isempty(valor)
%         indice=indice+1;
%         vector_masa(indice)=i;
%     end
% end

indice=0;
for i=1:masa_max
    if ~ismember(i,masa)
        indice=indice+1;
        vector_masa(indice)=i;
    end
end

% Aleatorizo el vector masa
vector_masa_aleatorio=randsample(vector_masa,length(vector_masa));
vector_masa=vector_masa_aleatorio;


for i=1:length(vector_masa)
    masa_equivalente=vector_masa(i)*equi_TNT;
    % Clculo z escalada:
    distancia_p5000=exp(log(5000/(1.83*1e5))/-1.16);    % Zona de Alerta escalada (5000 Pascales).
    distancia_p12500=exp(log(12500/(1.13*1e6))/-2.01);  % Zona de Intervencin escalada (12500 Pascales).
    distancia_p16000=exp(log(16000/(1.13*1e6))/-2.01);  % Zona de Efecto Domin escalada (16000 Pascales).
    % Clculo z:
    distancia_5000(i)=distancia_p5000*(masa_equivalente^(1/3));   % Zona de Alerta (5000 Pascales). 
    distancia_12500(i)=distancia_p12500*(masa_equivalente^(1/3)); % Zona de Intervencin (12500 Pascales).
    distancia_16000(i)=distancia_p16000*(masa_equivalente^(1/3)); % Zona de Efecto Domin (16000 Pascales).
end

figure()
plot (vector_masa,distancia_5000,'x');
title 'Alert Zone';
xlabel 'Mass [kg]';
ylabel 'Distance [m]';
grid on;

figure()
plot (vector_masa,distancia_12500,'x');
title 'Zona de Intervencion';
xlabel 'Masa [kg]';
ylabel 'Distancia [m]';
grid on;

figure()
plot (vector_masa,distancia_16000,'x');
title 'Zona de Efecto Domino';
xlabel 'Masa [kg]';
ylabel 'Distancia [m]';
grid on;

% Escritura del fichero con los resultados.

fID=fopen('solucionesFinalTest.txt','wt');              % Crea fichero de salida "Train"
formato='%5.5f %5.5f %5.5f %5.5f\n';                    % Define formato.
for i=1:length(vector_masa)                             % Para cada masa inserta...
    fprintf(fID,'%5.5f, ',vector_masa(i));              % ... masa, ...
    fprintf(fID,'%5.5f, ',distancia_5000(i));           % ... Zona de Alerta, ...
    fprintf(fID,'%5.5f, ',distancia_12500(i));          % ... Zona de Intervencin, ...
    fprintf(fID,'%5.5f \n',distancia_16000(i));         % ... Zona de Efecto Domin.
end
fclose(fID);

% Normalizacin entre 0.1 y 0.9 (aproximadamente).

masa_minima=min(min(masaTrain),min(masaTest));  % Busca el mnimo y mximo de cada variable.
masa_maxima=max(max(masaTrain),max(masaTest));
za_minima=min(min(zaTrain),min(zaTest));
za_maxima=max(max(zaTrain),max(zaTest));
zi_minima=min(min(ziTrain),min(ziTest));
zi_maxima=max(max(ziTrain),max(ziTest));
zd_minima=min(min(zdTrain),min(zdTest));
zd_maxima=max(max(zdTrain),max(zdTest));

nuevoIntervalo=0.8;                             % 0.9 - 0.1

%Normaliza en conjunto de test final.
masaEscalada=0.1+(vector_masa-masa_minima)*nuevoIntervalo/(masa_maxima-masa_minima);
zaEscalada=0.1+(distancia_5000-za_minima)*nuevoIntervalo/(za_maxima-za_minima);
ziEscalada=0.1+(distancia_12500-zi_minima)*nuevoIntervalo/(zi_maxima-zi_minima);
zdEscalada=0.1+(distancia_16000)*nuevoIntervalo/(zd_maxima-zd_minima);

% Escritura del fichero con los resultados.

fID=fopen('solucionesNormalFinalTest.txt','wt');        % Crea fichero de salida
formato='%5.5f %5.5f %5.5f %5.5f\n';                    % Define formato.
for i=1:length(vector_masa)                               % Para cada masa inserta...
    fprintf(fID,'%5.5f, ',masaEscalada(i));             % ... masa, ...
    fprintf(fID,'%5.5f, ',zaEscalada(i));               % ... Zona de Alerta, ...
    fprintf(fID,'%5.5f, ',ziEscalada(i));               % ... Zona de Intervencin, ...
    fprintf(fID,'%5.5f \n',zdEscalada(i));              % ... Zona de Efecto Domin.
end
fclose(fID);

